// POSSIBLE WORLDS
// by Gerwin Sturm & Eike Umlauf
//
// This software is distributed under the terms of the GNU Public License
// as published by the Free Software Foundation.
//
// possibleworlds@eik.at
// http://possibleworlds.cjb.net
//

#include "intro.h"
#include "psworlds.h"
#include "sound.h"
#include "menu.h"
#include "fonts.h"
#include "utility.h"

#define INTRO_FADESPEED 0.75
#define MOD_FADESPEED INTRO_FADESPEED

#define INTROVOL 136
#define MP3VOL 255

intro::intro(int mode)
{
	_FBUF

	write_log("Creating intro...");

	for(int i=0;i<20;i++){ img[i]=NULL; for(int j=0; j<10; j++) { fo[i][j]=2; txt[i][j]=NULL; }}
	al1=0.0;
	al2=0.0;
	this->timeleft=0.0;
	step=0;
	numsteps=0;
	killme=0;
	quit=0;
	vol=INTROVOL;
	this->mode = mode;
	chl[1] = CHARLEN;
	chl[2] = CHARLEN/4*3;

	// script intro and outro sequences
	switch(mode)
	{
	case INTRO:
		sprintf(buf,"gfx/intro/bush-intro.tga"); img[2]=new textureObj(buf,1);
		sprintf(buf,"gfx/intro/bill-intro.tga"); img[3]=new textureObj(buf,1);
		sprintf(buf,"gfx/intro/bill-intro.tga"); img[4]=new textureObj(buf,1);
		sprintf(buf,"gfx/intro/lawandorder.tga"); img[5]=new textureObj(buf,1);
		sprintf(buf,"gfx/intro/guilty.tga"); img[6]=new textureObj(buf,1);
		sprintf(buf,"gfx/intro/attack.tga"); img[7]=new textureObj(buf,1);
		sprintf(buf,"gfx/intro/nato.tga"); img[8]=new textureObj(buf,1);
		sprintf(buf,"gfx/intro/nato.tga"); img[9]=new textureObj(buf,1);
		sprintf(buf,"gfx/intro/ues.tga"); img[10]=new textureObj(buf,1);
		sprintf(buf,"gfx/intro/economy.tga"); img[11]=new textureObj(buf,1);
		sprintf(buf,"gfx/intro/news.tga"); img[12]=new textureObj(buf,1);
		sprintf(buf,"gfx/intro/news.tga"); img[13]=new textureObj(buf,1);
		sprintf(buf,"gfx/intro/scientists.tga"); img[14]=new textureObj(buf,1);
		sprintf(buf,"gfx/intro/spy.tga"); img[15]=new textureObj(buf,1);
		sprintf(buf,"gfx/intro/raceison.tga"); img[16]=new textureObj(buf,1);
		sprintf(buf,"gfx/intro/raceison.tga"); img[17]=new textureObj(buf,1);



		makestring(txt[0][0], "PROLOGO"); fo[0][0]=1;

		makestring(txt[1][1], "2000 D.C."); fo[1][1]=1;

		makestring(txt[2][0], "GEORGE W. BUSH CONSIGUE");
		makestring(txt[2][1], "LA PRESIDENCIA DE EE.UU");

		makestring(txt[3][0], "JUNIO 2008"); fo[3][0] = 1;
		makestring(txt[3][2], "EL JUICIO A MICROSOFT, FORZADO POR LOS LOBBYS");
		makestring(txt[3][3], "LEGALES Y LA ASOCIACION FEDERAL DE ABOGADOS AMERICANOS,");
		makestring(txt[3][4], "TOCA A SU FIN.");

		makestring(txt[4][1], "COMO RESULTADO, MICROSOFT ES CONDENADO A LIBERAR EL");
		makestring(txt[4][2], "CODIGO DE TODA SU LINEA DE PRODUCTOS WINDOWS.");

		makestring(txt[5][0], "JULIO 2008"); fo[5][0]=1;
		makestring(txt[5][2], "NETSCAPE / AOL, SUN MICROSYSTEMS, APPLE Y OTRAS MUCHAS");
		makestring(txt[5][3], "EMPRESAS DEMANDAN A MICROSOFT POR VARIAS VIOLACIONES");
		makestring(txt[5][4], "DE PATENTES, COMPETENCIA DESLEAL, Y OTRAS 104 ");
		makestring(txt[5][5], "ACUSACIONES.");

		makestring(txt[6][0], "SEPTIEMBRE 2009"); fo[6][0]=1;
		makestring(txt[6][2], "LA CORTE DE LOS EE.UU. DECLARA A MICROSOFT CULPABLE.");
		makestring(txt[6][3], "LA ECONOMIA AMERICANA, COMPLETAMENTE ORIENTADA A LAS N.T,");
		makestring(txt[6][4], "Y DEBILITADA POR EL LIDERAZGO DE GEORGE W. BUSH, COLAPSA.");

		makestring(txt[7][0], "EN UN MOVIMIENTO DESESPERADO PARA DESVIAR LA ATENCION DE");
		makestring(txt[7][1], "LOS PROBLEMAS INTERNOS, EL EJERCITO AMERICANO ATACA");
		makestring(txt[7][2], "OBJETIVOS EN EX-YUGOSLAVIA PARA \"PREVENIR ACCIONES");
		makestring(txt[7][3], "TERRORISTAS DE FANATICOS ISLAMICOS QUE REPRESENTAN UNA");
		makestring(txt[7][4], "SERIA AMENAZA PARA LA SEGURIDAD NACIONAL\", TECNICA YA");
		makestring(txt[7][5], "UTILIZADA POR EL ANTERIOR PRESIDENTE BILL CLINTON.");
		
		makestring(txt[8][0], "DICHA TECNICA NO CONSIGUE SU OBJETIVO,");
		makestring(txt[8][1], "LAS RELACIONES EE.UU. - EUROPA SE DETERIORAN.");

		makestring(txt[9][0], "OCTUBRE 2010"); fo[9][0]=1;
		makestring(txt[9][2], "LA OTAN ES DISUELTA DEBIDO A DISCREPANCIAS INTERNAS.");

		makestring(txt[10][0], "ABRIL 2011"); fo[10][0]=1;
		makestring(txt[10][2], "CRISIS ECONOMICA EN EE.UU., LOS INTERESES");
		makestring(txt[10][3], "MILITARES COMUNES SE INTEGRAN EN LA U.E., AMPLIADA");
		makestring(txt[10][4], "Y RENOMBRADA COMO \"UNION DE ESTADOS EUROPEOS\" (U.E.S.)");

		makestring(txt[11][0], "MEDIADOS DE 2013"); fo[11][0]=1;
		makestring(txt[11][2], "ESTADO ACTUAL DEL MUNDO:");
		makestring(txt[11][3], "UES Y EE.UU. APROXIMADAMENTE IGUALADOS,");
		makestring(txt[11][4], "ECONOMICAMENTE.");

		makestring(txt[12][0], "12 DE MARZO, 2015"); fo[12][0]=1;
		makestring(txt[12][2], "UN OBJETO VOLADOR NO IDENTIFICADO SE ESTRELLA EN EL");
		makestring(txt[12][3], "OCEANO ATLANTICO. LAS FUERZAS NAVALES BRITANICAS Y");
		makestring(txt[12][4], "AMERICANAS COMPITEN PARA RECOGER LOS RESTOS DEL OVNI.");

		makestring(txt[13][0], "AMBOS BANDOS OBTIENEN PARTES DE LOS RESTOS DEL OVNI.");
		makestring(txt[13][1], "ES LA PRIMERA VEZ EN LA HISTORIA EN LA QUE UN");
		makestring(txt[13][2], "DESCUBRIMIENTO COMO ESTE SE ADMITE POR LOS GOBIERNOS,");
		makestring(txt[13][3], "SE HACEN PUBLICAS IMAGENES OFICIALES.");

		makestring(txt[14][0], "AGOSTO 2015"); fo[14][0]=1;
		makestring(txt[14][2], "LOS CIENTIFICOS SE EMBARCAN EN DESCIFRAR PARTE");
		makestring(txt[14][3], "DE LOS DATOS ALMACENADOS EN EL OVNI. LAS GRABACIONES");
		makestring(txt[14][4], "DESCRIBEN 4 LOCALIZACIONES DE ESTACIONES DE");
		makestring(txt[14][5], "OBSERVACION EXTRATERRESTRE NO TRIPULADAS EN EL FONDO");
		makestring(txt[14][6], "MARINO. (EXTRATERRESTRIAL SEAFLOOR STATIONS, E.S.S)");

		makestring(txt[15][0], "DEBIDO A UN INPREDECIBLE INCIDENTE DE ESPIONAJE");
		makestring(txt[15][1], "QUE IMPLICA UN MONOVOLUMEN, UN CEPILLO DE DIENTES");
		makestring(txt[15][2], "ELECTICO, Y UN PROTOTIPO DE HORNO MICROONDAS NUCLEAR,");
		makestring(txt[15][3], "EE.UU. Y U.E.S SE HACEN CON ESTA");
		makestring(txt[15][4], "INFORMACION.");

		makestring(txt[16][0], "SEPTIMBRE 2015"); fo[16][0]=1;
		makestring(txt[16][2], "EXPERTOS Y PERSONAL DEL SERVICIO SECRETO CONCLUYEN:");
		makestring(txt[16][3], "LA TECNOLOGIA ALIEN QUE SE SOSPECHA PRESENTE EN LOS ESS");
		makestring(txt[16][4], "GARANTIZARA A QUIEN LA DESCUBRA Y EVALUE");
		makestring(txt[16][5], "UN PRIMER PUESTO EN EL LIDERAZGO MILITAR Y");
		makestring(txt[16][6], "ECONOMICO DURANTE EL SIGLO XXI.");

		makestring(txt[17][0], "LA CARRERA POR QUIEN SERA"); fo[17][0]=1;
		makestring(txt[17][1], "LA PROXIMA SUPERPOTENCIA HA EMPEZADO!"); fo[17][1]=1;



		tm[0] = 5.0; tm[1] = 5.0; tm[2] = 8.0; tm[3]=11; tm[4] = 7; tm[5]=14.0; tm[6]=14.0;
		tm[7] = 19.0; tm[8] = 7.0; tm[9] = 8.0; tm[10] = 12.0; tm[11] = 11.0;
		tm[12] = 13.0; tm[13] = 13.0; tm[14] = 18.0; tm[15] = 15.0; tm[16] = 17.0; tm[17]=9.0;
		numsteps=18;

		beginvol = INTROVOL;
		musicfadespeed = MOD_FADESPEED;
		sprintf(buf,"sfx/turrican2_(eik_remix).mod");
		loadmod(buf); setmodvol(beginvol);
		musi = MOD;
		break;
	case OUTRO:
		sprintf(buf,"gfx/intro/openess.tga"); img[2]=new textureObj(buf,1);
		sprintf(buf,"gfx/intro/amazed.tga"); img[3]=new textureObj(buf,1);
		sprintf(buf,"gfx/intro/amazed.tga"); img[4]=new textureObj(buf,1);
		sprintf(buf,"gfx/intro/ontheweb.tga"); img[5]=new textureObj(buf,1);
		sprintf(buf,"gfx/intro/newspaper1.tga"); img[7]=new textureObj(buf,1);
		sprintf(buf,"gfx/intro/news2.tga"); img[8]=new textureObj(buf,1);
		sprintf(buf,"gfx/intro/news3.tga"); img[6]=new textureObj(buf,1);
		sprintf(buf,"gfx/intro/believe.tga"); img[9]=new textureObj(buf,1);
		sprintf(buf,"gfx/intro/futurespace.tga"); img[10]=new textureObj(buf,1);
		sprintf(buf,"gfx/intro/alienplanet.tga"); img[11]=new textureObj(buf,1);
		sprintf(buf,"gfx/intro/theend.tga"); img[12]=new textureObj(buf,1);
		sprintf(buf,"gfx/intro/theend2.tga"); img[13]=new textureObj(buf,1);
		

		makestring(txt[0][0], "EPILOGO"); fo[0][0]=1;

		makestring(txt[1][1], "23 DE FEBRERO, 2016"); fo[1][1]=1;

		makestring(txt[2][0], "CIENTIFICOS DE U.E.S ABREN EL ESS CAPTURADO PARA");
		makestring(txt[2][1], "OBTENER ACCESO A SU TECNOLOGIA ALIENIGENA.");

		makestring(txt[3][0], "LOS RESULTADOS VAN MAS ALLA DE LO ESPERADO:");
		makestring(txt[3][1], "EL ESS PARECE MAS UN METODO PARA ENTREGAR UN MENSAJE");
		makestring(txt[3][2], "DE LA RAZA ALIEN A LA HUMANIDAD QUE");
		makestring(txt[3][3], "UNA ESTACION DE OBSERVACION.");

		makestring(txt[4][0], "NO SOLO INCLUYE MODELOS DE LA ANATOMIA");
		makestring(txt[4][1], "ALIEN, SINO TAMBIEN DE LA LOCALIZACION DE SU");
		makestring(txt[4][2], "DISTANTE SISTEMA SOLAR, INCLUYENDO INFORMACION");
		makestring(txt[4][3], "ECONOMICA, MEDIOAMBIENTAL Y SOCIAL, ASI COMO ");
		makestring(txt[4][4], "TODO UN TESORO DE DOCUMENTACION Y EJEMPLOS");
		makestring(txt[4][5], "DE SU SUPREMACIA TECNOLOGICA.");

		makestring(txt[5][0], "4 DE MARZO, 2012"); fo[5][0]=1;
		makestring(txt[5][2], "LOS RESPONSABLES CIENTIFICOS DE LA U.E.S, IMPRESIONADOS");
		makestring(txt[5][3], "POR LA ENORME SUPERIORIDAD TECNOLOGICA DE LA RAZA ALIEN,");
		makestring(txt[5][4], "PUBLICAN EN INTERNET TODA LA INFORMACION OBTENIDA.");
		
		makestring(txt[6][0], "A PESAR DE QUE EL SERVICIO SECRETO Y EL GOBIERNO");
		makestring(txt[6][1], "TRATAN DESESPERADAMENTE DE RETENER LOS VALIOSOS");
		makestring(txt[6][2], "DOCUMENTOS, ES DEMASIADO TARDE.");
		makestring(txt[6][3], "LOS SERVIDORES WEB CONTENIENDO LA INFORMACION ALIEN ESTAN");
		makestring(txt[6][4], "CONSTANTEMENTE SOBRECARGADOS, LOS MEDIOS ESTAN");
		makestring(txt[6][5], "LLENOS DE CONTENIDOS RELACIONADOS.");

		makestring(txt[7][0], "A PESAR DE QUE EL SERVICIO SECRETO Y EL GOBIERNO");
		makestring(txt[7][1], "TRATAN DESESPERADAMENTE DE RETENER LOS VALIOSOS");
		makestring(txt[7][2], "DOCUMENTOS, ES DEMASIADO TARDE.");
		makestring(txt[7][3], "LOS SERVIDORES WEB CONTENIENDO LA INFORMACION ALIEN ESTAN");
		makestring(txt[7][4], "CONSTANTEMENTE SOBRECARGADOS, LOS MEDIOS ESTAN");
		makestring(txt[7][5], "LLENOS DE CONTENIDOS RELACIONADOS.");

		makestring(txt[7][0], "A PESAR DE QUE EL SERVICIO SECRETO Y EL GOBIERNO");
		makestring(txt[7][1], "TRATAN DESESPERADAMENTE DE RETENER LOS VALIOSOS");
		makestring(txt[7][2], "DOCUMENTOS, ES DEMASIADO TARDE.");
		makestring(txt[7][3], "LOS SERVIDORES WEB CONTENIENDO LA INFORMACION ALIEN ESTAN");
		makestring(txt[7][4], "CONSTANTEMENTE SOBRECARGADOS, LOS MEDIOS ESTAN");
		makestring(txt[7][5], "LLENOS DE CONTENIDOS RELACIONADOS.");

		makestring(txt[9][0], "EL CONFLICTO SE HA HECHO OBSOLETO, EL MUNDO ENTERO");
		makestring(txt[9][1], "TIENE AHORA ACCESO A MATERIAL DE ALTO SECRETO.");
		makestring(txt[9][2], "LA HUMANIDAD ESTA ABRUMADA POR LA AVANZADA TECNOLOGIA");
		makestring(txt[9][3], "Y LAS DETALLADAS DESCRIPCIONES DE LA CULTURA ALIENIGENA.");
		makestring(txt[9][4], "TODO TIENE UN NUEVO SIGNIFICADO, LA GENTE ESTA LLENA");
		makestring(txt[9][5], "DE UN NUEVO Y ABIERTO ESPIRITU.");

		makestring(txt[10][0], "12 DE MAYO, 2016"); fo[10][0]=1;
		makestring(txt[10][2], "TRAS SEMANAS DE DEBATO, EE.UU Y LA U.E.S");
		makestring(txt[10][3], "PONEN FINALMENTE FIN AL CONFLICTO E INICIAN UN");
		makestring(txt[10][4], "IMPRESIONANTE Y AMBICIOSO PROYECTO ESPACIAL CONJUNTO.");
		
		makestring(txt[11][0], "EL OBJETIVO ES REPRODUCIR PARTES DE LA TECNOLOGIA");
		makestring(txt[11][1], "ALIEN PARA SER CAPACES DE ENTABLAR CONTACTO CON LA");
		makestring(txt[11][2], "RAZA EXTRATERRESTRE ALGUN DIA.");

		makestring(txt[12][0], "ES ESTO SOLO UNA EXCUSA PARA UNA SECUELA DE");
		makestring(txt[12][1], "ESTE JUEGO, O PODRIA ALGUNA VEZ SER UNA PAZ");
		makestring(txt[12][2], "REAL Y EL FINAL DE TODOS LOS CONFLICTOS EN LA TIERRA?");

		makestring(txt[13][0], "QUIEN SABE..");
		makestring(txt[13][1], "HAY MAS DE UN");
		makestring(txt[13][3], "MUNDO POSIBLE"); fo[13][3]=1;
	

		tm[0] = 5.0; tm[1] = 5.0; tm[2] = 8.0; tm[3]=12; tm[4] = 15.0; tm[5]=12.0; tm[6]=11.0;
		tm[7] = 10.0; tm[8] = 9.0;
		tm[9] = 17.0; tm[10] = 13.0; tm[11] = 11.0; tm[12] = 10.0; tm[13] = 10.0;
		numsteps=14;

		beginvol = MP3VOL;
		musicfadespeed = MOD_FADESPEED;
		sprintf(buf,"sfx/chris_huelsbeck-turrican_credits.mp3");
		loadmp3(buf);
		musi = MP3;
		break;
	}

	timeleft = tm[0];
	prevtime = timeleft;

	initsound();
	vol = beginvol;
	write_log("done!\n");
}

intro::~intro()
{
	for(int i=0; i<20; i++)
	{
		for(int j=0; j<10; j++)
		{
			if(txt[i][j]!=NULL)
			{
				char* ctmp = txt[i][j];
				delete ctmp;
				txt[i][j]=NULL;
			}
		}
		if(img[i]!=NULL)
		{
			textureObj* tmp = img[i];
			delete tmp;
			img[i]=NULL;
		}
	}
	initnormalvoices();
	write_log("Intro quitted\n");
}


void intro::initsound()
{
	// reserve channels for music mod
	
	// destroy all previous channels
	destroyvoices();
	initintrovoices();

}


void intro::control()
{
	// read keyboard commands, control time and fading
	kbd();
	char* keys = getkeys();
	GLfloat ticks = gettime();

	this->timeleft-=ticks;
	

	if(keys[SDLK_ESCAPE] && quit==0) // quit intro
	{
		keys[SDLK_ESCAPE]=0;
		quit=1;
		timeleft=1.0/INTRO_FADESPEED; prevtime=1.0/INTRO_FADESPEED;
	}
	if(keys[SDLK_RETURN] && this->timeleft>0.0) // next slide
	{
		keys[SDLK_RETURN]=0;
		this->timeleft=-0.1;
		prevtime=0.1;
	}

	if(timeleft>0.0 && quit==0) // fade in pic!
	{
		switch(step%2) // switch odd / even steps
		{
		case 0:	// even
			if(al1<1.0) al1+=ticks*INTRO_FADESPEED;
			if(al2>0.0) al2-=ticks*INTRO_FADESPEED;
			break;
		case 1:	// odd
			if(al2<1.0) al2+=ticks*INTRO_FADESPEED;
			if(al1>0.0) al1-=ticks*INTRO_FADESPEED;
			break;
		}
	}
	// the break!
	if(prevtime>0.0 && timeleft<0.0)
	{
		if(quit==1) killme=1;
		step++;
		if(step<numsteps) timeleft=this->tm[step];
		else {timeleft = 1.0/INTRO_FADESPEED; quit=1; }
	}

	if(timeleft<0.0 && quit==0) // fade out pic!
	{
		switch(step%2) // switch odd / even steps
		{
		case 0:	// even
			if(al2<1.0) al2+=ticks*INTRO_FADESPEED;
			if(al1>0.0) al1-=ticks*INTRO_FADESPEED;
			break;
		case 1:	// odd
			if(al1<1.0) al1+=ticks*INTRO_FADESPEED;
			if(al2>0.0) al2-=ticks*INTRO_FADESPEED;
			break;
		}
	}
	if(quit==1)
	{
		al1-=ticks*INTRO_FADESPEED;
		al2-=ticks*INTRO_FADESPEED;
		vol-=beginvol*ticks*musicfadespeed;
		if(musi==MOD)setmodvol(vol);
		else setmp3vol(vol);
	}

	prevtime=timeleft;

}


void intro::display()
{
	// display all text and gfx
	int thisstep, j;
	GLfloat alpha;

	// very simple gfx pipeline!
	glEnable(GL_TEXTURE_2D);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glClearColor(0, 0, 0, 0);
	glClear(GL_COLOR_BUFFER_BIT);
	glPushMatrix();

	for(int i=0; i<2; i++)
	{
		thisstep = step-1+i;
		if(thisstep>=0 && thisstep<numsteps)
		{
			// draw the picture
			if(thisstep%2==0) alpha = al1; else alpha=al2;
			if(img[thisstep]!=NULL)
			{
				glBindTexture(GL_TEXTURE_2D, img[thisstep]->id);
				glColor4f(1.0, 1.0, 1.0, alpha);
				glBegin(GL_QUADS);
					glTexCoord2f(0.0,1.0); glVertex3f(-128*0.0025, 266*0.0027, -1.5000001);
					glTexCoord2i(0.0,0.0); glVertex3f(-128*0.0025, 10*0.0027, -1.5000001);
					glTexCoord2i(1.0,0.0); glVertex3f(128*0.0025, 10*0.0027, -1.5000001);
					glTexCoord2i(1.0,1.0); glVertex3f(128*0.0025, 266*0.0027, -1.5000001);
				glEnd();
			}
			// then the text
			for(j=0; j<10; j++)
			{
				if(txt[thisstep][j]!=NULL)
					print(strlen(txt[thisstep][j])/2*-chl[fo[thisstep][j]]+400, 340+j*30, txt[thisstep][j], fo[thisstep][j], 0.5, 0.63, 1.0, alpha);
			}
		}
	}
	glPopMatrix();
	drawstrings();

	// the usual suspects
	glFlush();
	SDL_GL_SwapBuffers();
}


void intro::run()
{
	// the sequence main loop
	timing();
	glDisable(GL_LIGHTING);
	glDisable(GL_DEPTH_TEST);
	glDisable(GL_CULL_FACE);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE);
	glEnable(GL_TEXTURE_2D);
	glDisable(GL_COLOR_MATERIAL);
	if(musi==MOD)
	{

		playmod();
	}
	else
	{
		playmp3(beginvol);
	}
	
	while(killme==0)
	{
		timing();
		
		control();
		display();
	}

	if(musi==MOD)
	{
		stopmod();
	}
	else
	{
		stopmp3();
	}
	glEnable(GL_LIGHTING);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_CULL_FACE);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glDisable(GL_TEXTURE_2D);
	
}


